DavidsGrail (quaternion) {
//David Makin's 3D mandelbrot.
//Probably it's an actual 3D mandelbrot.
//Exept that it's a 4D.

parameter real bailout;
quaternion C;
real zx, zy, zz, zzx, zzy, zzz, Cx, Cy, Cz, root2, m, n;
parameter bool testInverted;
parameter quaternion julia;
parameter int settype, power;
complex newz, w;
parameter real perturb;

// block for cutout.
parameter int iscuted;
parameter quaternion Ctaxis;
real autobailout, coordX, coordY, coordZ;


void init(void)
 {
	
 	 if (testInverted==true && settype=="Julia Set")
	 {
	z = recip(pixel);
	C = julia;
	}
     else if (settype=="Julia Set")
    {	
	z = pixel;
	C = julia;
    }
    else if (testInverted==true && settype=="Mandelbrot Set")
	 {
	 z= 0;
	 C= recip(pixel);
	 }
    else
    {
	z= 0;
	C= pixel;
    } 
	
		Cx=real(C);
		Cy=imag(C);
		Cz=part_j(C);	

		
//block for cutout. An unelegant code.
autobailout=0;
coordX= real(Ctaxis);
coordY= imag(Ctaxis);
coordZ= part_j(Ctaxis);
if (iscuted == "Larger than") 
{
	if (coordX!=0 && real(pixel) > coordX )
	{
	autobailout= bailout +1;
	}
	if (coordY!=0 && imag(pixel) > coordY )
	{
	autobailout= bailout +1;
	}
	if (coordZ!=0 && part_j(pixel) > coordZ )
	{
	autobailout= bailout +1;
	}
}	
else if (iscuted == "Smaller than")
{
	if (coordX!=0 && real(pixel) < coordX )
	{
	autobailout= bailout +1;
	}
	if (coordY!=0 && imag(pixel) < coordY )
	{
	autobailout= bailout +1;
	}
	if (coordZ!=0 && part_j(pixel) < coordZ )
	{
	autobailout= bailout +1;
	}
}	
	 

		w=complex(part_j(z), 0);
		newz=complex ( real(z),  imag(z) );
}		
void loop(void)	
{

m = |newz|+|w|; //square of 4D mag
if (m>0)  // Chaos pro eliminates but anyway
{
	if (power=="Square")
	{
    w = 2.0*newz*w;
    newz = 2.0*sqr(newz);
    n = cabs(newz);
    newz = newz*(n-m)/n;
	}
	else if (power=="Tesseract")
	{ //4th power
    w = 2.0*newz*w;
    newz = 2.0*sqr(newz);
    n = cabs(newz);
    newz = newz*(n-m)/n;
    m = |newz| + |w|;
    w = 2.0*newz*w;
    newz = 2.0*sqr(newz);
    n = cabs(newz);
    newz = newz*(n-m)/n;
	}
	if (power=="Octeract")
	{
    w = 2.0*newz*w;
    newz = 2.0*sqr(newz);
    n = cabs(newz);
    newz = newz*(n-m)/n;
    m = |newz| + |w|;
    w = 2.0*newz*w;
    newz = 2.0*sqr(newz);
    n = cabs(newz);
    newz = newz*(n-m)/n;
    m = |newz|+|w|;
    w = 2.0*newz*w;
    newz = 2.0*sqr(newz);
    n = cabs(newz);
    newz = newz*(n-m)/n;
	}

}
newz=newz+complex(Cx,Cy);
w=w+complex(Cz,perturb);
z=newz+w;

}
bool bailout(void)
	{
	return( |newz|+|w|+ autobailout < bailout );
	}
void description(void)
	{
this.title = "DavidsGrail";
this.maxiter=20;

	bailout.caption = "Bailout Value";
	bailout.default = 777.0;
	bailout.hint = "Larger number increases detalisation";
   
settype.caption = "Set type";
settype.enum = "Mandelbrot Set\nJulia Set";
settype.default = 0;

    testInverted.caption="Inverted set";
    testInverted.default=false;
	 
    power.caption = "Power";
    power.enum = "Square\nTesseract\nOcteract";
    power.default = 0;

    perturb.caption = "4th dim slice";
    perturb.default = 0;
    perturb.visible = (settype=="Mandelbrot Set");

separator.label1.caption  = "4th dimension is unused.";
    julia.caption = "Julia Parameter";
    julia.default = (0.2,-0.3,0.27,0);
    julia.visible = (settype=="Julia Set");
	 
//block for a cutout.	 
separator.label2.caption  = "CUTS along NONZERO coordinates.";		
iscuted.caption="CUTTING";
iscuted.enum="None\nLarger than\nSmaller than";
iscuted.default= 0;
		
Ctaxis.caption ="Coordinates of cut";
Ctaxis.default= (0,0,0,0);
Ctaxis.visible = (iscuted=="Larger than" || iscuted=="Smaller than");

//	separator.label3.caption  = "Zoom inside of the fractal.";		
	}
}
PerpendicularDavids {
//Perpendicular mandelbro of DM 3D mandelbrot
//Cutted in the worst place.
//Could be mistakes in this code and julias.

parameter real bailout;
quaternion C, altZ;
real zx, zy, zz, zzx, zzy, zzz, Cx, Cy, Cz, root2, m, n;
parameter bool testInverted;
parameter quaternion julia, perturb;
parameter int settype, power;
complex newz, w;

void init(void)
 {
 	 if (testInverted==true && settype=="Julia Set")
	 {
	altZ = recip(pixel);
	C = julia;
	}
     else if (settype=="Julia Set")
    {	
	altZ = pixel;
	C = julia;
    }
    else if (testInverted==true && settype=="Mandelbrot Set")
	 {
	 altZ= perturb;
	 C= recip(pixel);
	 }
    else
    {
	altZ= perturb;
	C= pixel;
    } 
	
		Cy=real(C);
		Cz=imag(C);
		Cx=part_j(C);

		w=imag(altZ);
		newz=complex ( real(altZ),  part_j(altZ) );
				
}		
void loop(void)	
{

m = |newz|+|w|; //square of 4D mag
if (m>0)  // Chaos pro eliminates but anyway
{
	if (power=="Square")
	{
    w = 2.0*newz*w;
    newz = 2.0*sqr(newz);
    n = cabs(newz);
    newz = newz*(n-m)/n;
	}
	else if (power=="Tesseract")
	{ //4th power
    w = 2.0*newz*w;
    newz = 2.0*sqr(newz);
    n = cabs(newz);
    newz = newz*(n-m)/n;
    m = |newz| + |w|;
    w = 2.0*newz*w;
    newz = 2.0*sqr(newz);
    n = cabs(newz);
    newz = newz*(n-m)/n;
	}
	if (power=="Octeract")
	{
    w = 2.0*newz*w;
    newz = 2.0*sqr(newz);
    n = cabs(newz);
    newz = newz*(n-m)/n;
    m = |newz| + |w|;
    w = 2.0*newz*w;
    newz = 2.0*sqr(newz);
    n = cabs(newz);
    newz = newz*(n-m)/n;
    m = |newz|+|w|;
    w = 2.0*newz*w;
    newz = 2.0*sqr(newz);
    n = cabs(newz);
    newz = newz*(n-m)/n;
	}
}

newz=newz+complex(Cx,Cy);
w=w+Cz;
z=newz;

}
bool bailout(void)
	{
	return(  |newz|+|w|  <= bailout );
	}
void description(void)
	{
		this.title = "PerpendicularDavids";

		bailout.caption = "Bailout Value";
		bailout.default = 1000;

    power.caption = "Power";
    power.enum = "Square\nTesseract\nOcteract";
    power.default = 0;

    settype.caption = "Set type";
    settype.enum = "Mandelbrot Set\nJulia Set";
    settype.default = 0;

    testInverted.caption="Inverted set";
    testInverted.default=false;
	 
	 
    separator.label.caption  = "For Julia sets";
    julia.caption = "Julia Parameter";
    julia.default = (0.5,-0.3,0.7,0);
	}
}